package tools.descartes.dql.connector.simQPN.wastebasket;

import java.io.IOException;
import java.util.Collections;
import java.util.Map;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;

import edu.kit.ipd.descartes.qpme.model.ModelPackage;
import edu.kit.ipd.descartes.qpme.model.QueueingPetriNet;

public class EMFUtil {

	public static void saveQPN(QueueingPetriNet qpn, String path) {

		Resource.Factory.Registry reg = Resource.Factory.Registry.INSTANCE;

		Map<String, Object> m = reg.getExtensionToFactoryMap();

		m.put("qpe", new XMIResourceFactoryImpl());

		ResourceSet resSet = new ResourceSetImpl();

		Resource resource = resSet.createResource(URI.createURI(path));

		resource.getContents().add(qpn);

		try {

			resource.save(Collections.EMPTY_MAP);

		} catch (IOException e) {

			e.printStackTrace();

		}

	}

	public static QueueingPetriNet loadQPN(String modelPath) {

		ModelPackage.eINSTANCE.eClass();

		Resource.Factory.Registry reg = Resource.Factory.Registry.INSTANCE;

		Map<String, Object> m = reg.getExtensionToFactoryMap();

		m.put("qpe", new XMIResourceFactoryImpl());

		ResourceSet resSet = new ResourceSetImpl();

		Resource resource = resSet.getResource(URI.createURI(modelPath), true);

		QueueingPetriNet loadedQPN = (QueueingPetriNet) resource.getContents()

		.get(0);

		return loadedQPN;

	}

}
