package tools.descartes.dql.connector.simQPN.wastebasket;

import java.util.Map;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;

import edu.kit.ipd.descartes.qpme.model.ColorReference;
import edu.kit.ipd.descartes.qpme.model.ModelFactory;
import edu.kit.ipd.descartes.qpme.model.ModelPackage;
import edu.kit.ipd.descartes.qpme.model.Place;
import edu.kit.ipd.descartes.qpme.model.QpmeDocument;
import edu.kit.ipd.descartes.qpme.model.QueueingPetriNet;

public class RunBuild {
	public static void main(String[] args) {
		
		/** works */

		String path = "examples/generated.qpe";

		ModelFactory factory = ModelFactory.eINSTANCE;

		QpmeDocument qpnDocument = factory.createQpmeDocument();

		QueueingPetriNet qpn = ModelFactory.eINSTANCE.createQueueingPetriNet();

		qpn.setColors(ModelFactory.eINSTANCE.createColorsContainer());

		qpn.setPlaces(factory.createPlacesContainer());

		
		//Building places
		Place WLSPool = factory.createOrdinaryPlace();
		WLSPool.setName("WLS-Pool");
		qpn.getPlaces().getDefinitions().add(WLSPool);

		Place DBSPQ = factory.createOrdinaryPlace();
		DBSPQ.setName("DBS-PQ");
		qpn.getPlaces().getDefinitions().add(DBSPQ);

		Place DBSCPU = factory.createOrdinaryPlace();
		DBSCPU.setName("DBS-CPU");
		qpn.getPlaces().getDefinitions().add(DBSCPU);

		Place DBSIO = factory.createOrdinaryPlace();
		DBSIO.setName("DBS-I/O");
		qpn.getPlaces().getDefinitions().add(DBSIO);

		Place WLSThreadPool = factory.createOrdinaryPlace();
		WLSThreadPool.setName("WLS-Thread-Pool");
		qpn.getPlaces().getDefinitions().add(WLSThreadPool);

		Place Client = factory.createOrdinaryPlace();
		Client.setName("Client");
		qpn.getPlaces().getDefinitions().add(Client);
		
		//Colors
		 edu.kit.ipd.descartes.qpme.model.Color x1 = factory.createColor();
		 x1.setName("x1");
		 x1.setRealColor("#8f780b");
		 x1.setDescription("NewOrder Request");
		 qpn.getColors().getDefinitions().add(x1);
		 
		 edu.kit.ipd.descartes.qpme.model.Color x2 = factory.createColor();
		 x2.setName("x2");
		 x2.setRealColor("#df0a03");
		 x2.setDescription("ChangeOrder Request");
		 qpn.getColors().getDefinitions().add(x2);
		 
		 edu.kit.ipd.descartes.qpme.model.Color t = factory.createColor();
		 t.setName("t");
		 t.setRealColor("#3d4e34");
		 t.setDescription("WLS Thread");
		 qpn.getColors().getDefinitions().add(t);
		 
		 edu.kit.ipd.descartes.qpme.model.Color p = factory.createColor();
		 p.setName("p");
		 p.setRealColor("#9773d8");
		 p.setDescription("DBS Process");
		 qpn.getColors().getDefinitions().add(p);
			 
		 edu.kit.ipd.descartes.qpme.model.Color c = factory.createColor();
		 c.setName("c");
		 c.setRealColor("#16d392");
		 c.setDescription("DB Connection");
		 qpn.getColors().getDefinitions().add(c);

		 //Color References TODO how to add number?
		 WLSPool.setColorReferences(factory.createColorReferencesContainer());
		 ColorReference cr = factory.createOrdinaryColorReference();
		 cr.setColor(t);
		 WLSPool.getColorReferences().getDefinitions().add(cr);
//		 
//		 //transitions
//		 qpn.setTransitions(factory.createTransitionsContainer());
//		 //ImmediateTransition it = factory.createImmediateTransition();
		 
		qpnDocument.getNet().add(qpn);

		EMFUtil.saveQPN(qpn, path);	
		QueueingPetriNet loadedQPN = EMFUtil.loadQPN(path);

		for (Place place : loadedQPN.getPlaces()

		.getDefinitions()) {

			System.out.println(place.getName());

		}

		/** works not */

		// QueueingPetriNet loadedQPN =
		// loadQPN("examples/SPECjms2007Model.qpe");

	}

	public static QpmeDocument loadQPMEDocument(String modelPath) {

		ModelPackage.eINSTANCE.eClass();

		Resource.Factory.Registry reg = Resource.Factory.Registry.INSTANCE;

		Map<String, Object> m = reg.getExtensionToFactoryMap();

		m.put("qpe", new XMIResourceFactoryImpl());

		ResourceSet resSet = new ResourceSetImpl();

		Resource resource = resSet.getResource(URI.createURI(modelPath), true);

		QpmeDocument loadedQpmeDocument = (QpmeDocument) resource.getContents()
				.get(0);

		return loadedQpmeDocument;

	}

}
