package tools.descartes.dql.connector.simQPN.wastebasket;

import de.tud.cs.qpe.model.DocumentManager;
import de.tud.cs.qpe.model.NetHelper;
import de.tud.cs.qpe.model.PlaceHelper;
import de.tud.cs.simqpn.ui.model.BatchMeansConfiguration;
import de.tud.cs.simqpn.ui.model.Configuration;

import org.dom4j.Element;

public class RunConfigTest {

	public static void main(String[] args) {
//		Element net = loadNetFromFile("C:\\Users\\Simon\\Desktop\\qpme-2.0.1-win\\examples\\ispass03.qpe");

	}
	
	public static Configuration createBasicConfig(Element net) {
		DocumentManager.registerInput(net.getDocument());
		Configuration newConfiguration = createConfiguration(net);
		//Warmup Period
		newConfiguration.setRampUpLength(20);
		//Total Run time
		newConfiguration.setTotalRunLength(50);
		//Stopping Rule
		newConfiguration.setStoppingRule(Configuration.RELATIVE_PRECISION_STOPPING_RULE);
		//Time between Stop Checks
		newConfiguration.setTimeBetweenStopChecks(2);
		//Seconds between Stop Checks
		newConfiguration.setSecondsBetweenStopChecks(2);
		//Verbosity
		newConfiguration.setVerbosityLevel(0);
		//Output directory
		newConfiguration.setOutputDirectory(".");
		for (Element place: NetHelper.listAllPlaces(net)) {
			Element	placeMeta = PlaceHelper.createSimqpnPlaceConfigurationMetadata(place, newConfiguration.getName());
			placeMeta.addAttribute("statsLevel", "4");
		}
		return newConfiguration;
	}

	private static Configuration createConfiguration(Element net) {
		String name = "new configuration";
		Configuration conf = new BatchMeansConfiguration();
		conf.createSimulationConfiguration(net, name);
		conf.init(net);
		return conf;
	}

}
