package extension;

import java.math.BigDecimal;

import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;

import tools.descartes.dql.models.mapping.domain.DecimalResult;
import tools.descartes.dql.models.mapping.domain.impl.ResultImpl;

public class ExtendedDecimalResult extends ResultImpl implements DecimalResult{
	private BigDecimal value;
	private BigDecimal accuracy;
	
	public ExtendedDecimalResult clone() {
		ExtendedDecimalResult clone = new ExtendedDecimalResult();
		clone.setAccuracy(getAccuracy());
		clone.setMetricName(getMetricName());
		clone.setValid(getValid());
		clone.setValue(getValue());
		return clone;
	}
	
	public Element toXML() {
        Document document = DocumentHelper.createDocument();
        Element eDecimalResult = document.addElement("ExtendedDecimalResult")
        		.addAttribute("accuracy", accuracy.toString())
        		.addAttribute("metricName", getMetricName())
        		.addAttribute("valid", Boolean.toString(getValid()))
        		.addAttribute("value", value.toString());
		return eDecimalResult;
	}
	
	public String toString() {
		return toXML().asXML();
	}
	
	@Override
	public BigDecimal getValue() {
		return value;
	}

	@Override
	public void setValue(BigDecimal value) {
		this.value = value;
	}

	@Override
	public BigDecimal getAccuracy() {
		return accuracy;
	}

	@Override
	public void setAccuracy(BigDecimal value) {
		this.accuracy = value;
	}
}