package tools.descartes.dql.connector.simQPNV2;

import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.IPath;


public class FileUtil {
	
	public static String parsePath(String path) {
		if (path.matches("(\\\\|\\/).*")) {
			final IPath workspaceLocation = ResourcesPlugin.getWorkspace()
					.getRoot().getLocation();
			final IPath workspaceModelLocation = workspaceLocation
					.append(path);
			path = workspaceModelLocation.makeAbsolute().toOSString();
		}
		return path;
	}	

	public static Element loadXmlFromFile(String path) {
		path = parsePath(path);
		SAXReader xmlReader = new SAXReader();
		Document inputDoc = null;
		try {
			inputDoc = xmlReader.read(path);
		} catch (DocumentException e2) {
			throw new DQLException("Could not find the specified file or it is not a QPN net! \nPath:" + path);
		}
		return inputDoc.getRootElement();
	}
}
